package function.builtin.predicate;

import function.ArgumentValidator;
import function.FunctionNames;
import function.LispFunction;
import sexpression.Cons;
import sexpression.Nil;
import sexpression.SExpression;
import sexpression.Symbol;

@FunctionNames({ "ATOM", "ATOM?" })
public class ATOM extends LispFunction {

    private ArgumentValidator argumentValidator;

    public ATOM(String name) {
        this.argumentValidator = new ArgumentValidator(name);
        this.argumentValidator.setExactNumberOfArguments(1);
    }

    @Override
    public SExpression call(Cons argumentList) {
        argumentValidator.validate(argumentList);
        SExpression argument = argumentList.getFirst();

        return argument.isAtom() ? Symbol.Companion.getT() : Nil.INSTANCE;
    }
}
